/*
 *  The Mana Client
 *  Copyright (C) 2008  The Mana World Development Team
 *
 *  This file is part of The Mana Client.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "avatar.h"

#include "localplayer.h"

#include <sstream>

Avatar::Avatar(const std::string &name):
        mName(name),
        mOriginalName(name),
        mHp(0), mMaxHp(0),
        mDamageHp(0),
        mLevel(1),
        mOnline(false),
        mDisplayBold(false),
        mMap(""),
        mX(-1),
        mY(-1),
        mType(AVATAR_PLAYER)
{
}

std::string Avatar::getComplexName()
{
    if (mName == mOriginalName || mOriginalName.empty())
        return mName;
    else
        return mName + "(" + mOriginalName + ")";
}
