/*
 *  The Mana Client
 *  Copyright (C) 2004-2009  The Mana World Development Team
 *  Copyright (C) 2009-2010  The Mana Developers
 *
 *  This file is part of The Mana Client.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SKILLDIALOG_H
#define SKILLDIALOG_H

#include "guichanfwd.h"

#include "gui/widgets/window.h"

//include "resources/image.h"
//include "resources/resourcemanager.h"

#include <guichan/actionlistener.hpp>

#include <map>

class Button;
//class Image;
class Label;
class ScrollArea;
class Tab;
class TabbedArea;

//class SkillEntry;
//class SkillModel;

struct SkillInfo;

/*
struct SkillInfo
{
    unsigned short id;
    std::string name;
    Image *icon;
    bool modifiable;
    bool visible;
    SkillModel *model;

    std::string skillLevel;
    int skillLevelWidth;

    std::string skillExp;
    float progress;

    ~SkillInfo()
    {
        icon->decRef();
    }

    void setIcon(std::string iconPath)
    {
        ResourceManager *res = ResourceManager::getInstance();
        if (!iconPath.empty())
        {
            icon = res->getImage(iconPath);
        }
        else
        {
            icon = res->getSkinImage("graphics/gui/unknown-item.png");
        }
    }

    void update();

    void draw(Graphics *graphics, int y, int width);
};
*/

/**
 * The skill dialog.
 *
 * \ingroup Interface
 */
class SkillDialog : public Window, public gcn::ActionListener
{
    public:
        SkillDialog();

        ~SkillDialog();

        /**
         * Called when receiving actions from widget.
         */
        void action(const gcn::ActionEvent &event);

        /**
         * Update the given skill's display
         */
        std::string update(int id);

        /**
         * Update other parts of the display
         */
        void update();

        void loadSkills(const std::string &file);

        void setModifiable(int id, bool modifiable);

        SkillInfo* getSkill(int id);

        bool hasSkills()
        { return !mSkills.empty(); }

    private:
        typedef std::map<int, SkillInfo*> SkillMap;
        SkillMap mSkills;
        TabbedArea *mTabs;
        Label *mPointsLabel;
        Button *mIncreaseButton;
};

extern SkillDialog *skillDialog;

#endif
