/*
 *  The Mana Client
 *  Copyright (C) 2010  The Mana Developers
 *
 *  This file is part of The Mana Client.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "listener.h"

#include "eventmanager.h"

namespace Mana
{

Listener::~Listener()
{
    EventManager::remove(this);
}

void Listener::listen(const std::string &channel)
{
    EventManager::bind(this, channel);
}

void Listener::ignore(const std::string &channel)
{
    EventManager::unbind(this, channel);
}

} // namespace Mana
